/*
    cmd Task
    
*/

/* Includes ----------------------------------------------------------------- */
#include "task/user_task.h"
/* USER INCLUDE BEGIN */
#include "module/cmd.h"

/* USER INCLUDE END */

/* Private typedef ---------------------------------------------------------- */
/* Private define ----------------------------------------------------------- */
/* Private macro ------------------------------------------------------------ */
/* Private variables -------------------------------------------------------- */
/* USER STRUCT BEGIN */
CMD_RC_t rc_c;
Chassis_CMD_t cmd;
Gimbal_CMD_t g_cmd;
Shoot_CMD_t s_cmd;
/* USER STRUCT END */

/* Private function --------------------------------------------------------- */
/* Exported functions ------------------------------------------------------- */
void Task_cmd(void *argument) {
  (void)argument; /* 未使用argument，消除警告 */

  
  /* 计算任务运行到指定频率需要等待的tick数 */
  const uint32_t delay_tick = osKernelGetTickFreq() / CMD_FREQ;

  osDelay(CMD_INIT_DELAY); /* 延时一段时间再开启任务 */

  uint32_t tick = osKernelGetTickCount(); /* 控制任务运行频率的计时 */
  /* USER CODE INIT BEGIN */
 CMD_Init(&cmd,&g_cmd);
  /* USER CODE INIT END */
  
  while (1) {
    tick += delay_tick; /* 计算下一个唤醒时刻 */
    /* USER CODE BEGIN */
    osKernelLock(); /*锁住RTOS内核调度*/
    /*接受遥控器数据*/
if(osMessageQueueGet(task_runtime.msgq.cmd.raw.rc, &rc_c, NULL, 0)==osOK)
    CMD_ParseRc(&cmd, &rc_c, &g_cmd);

    CMD_CtrlSet(&cmd, &rc_c, &g_cmd,&s_cmd);

    // cmd.mode=HUIHANG_BIANXING_DUOLUN;

  osKernelUnlock(); /*解锁RTOS内核调度*/
    /*将需要与其他任务共享的数据放到消息队列里  */
		//发送给底盘
     osMessageQueueReset(task_runtime.msgq.chassis.c_cmd);
     osMessageQueuePut(task_runtime.msgq.chassis.c_cmd,&cmd,0,0);
     //发送给云台的数据
    //  osMessageQueueReset(task_runtime.msgq.gimbal.g_cmd);
    //  osMessageQueuePut(task_runtime.msgq.gimbal.g_cmd,&g_cmd,0,0);

    //  //发送给发射的数据
    //  osMessageQueueReset(task_runtime.msgq.shoot.cmd);
    //  osMessageQueuePut(task_runtime.msgq.shoot.cmd,&s_cmd,0,0 );

    /* USER CODE END */
    osDelayUntil(tick); /* 运行结束，等待下一次唤醒 */
  }
  
}